## ros-melodic-ypspur 1.20.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

set(_YPSPUR_MAJOR_VERSION 1)
set(_YPSPUR_MINOR_VERSION 17)
set(_YPSPUR_PATCH_VERSION 1)

if(${CMAKE_MAJOR_VERSION} LESS 3)
# DARN_IT: CMake 2 should be supported until April, 2019 (Ubuntu Trusty EOL)
  cmake_policy(VERSION 2.8.3)
  project(ypspur)

  set(YPSPUR_MAJOR_VERSION ${_YPSPUR_MAJOR_VERSION})
  set(YPSPUR_MINOR_VERSION ${_YPSPUR_MINOR_VERSION})
  set(YPSPUR_PATCH_VERSION ${_YPSPUR_PATCH_VERSION})

  set(PROJECT_VERSION ${_YPSPUR_MAJOR_VERSION}.${_YPSPUR_MINOR_VERSION}.${_YPSPUR_PATCH_VERSION})

  message(WARNING "[deprecated] CMake 2 will be obsoleted in yp-spur build at April, 2019")
else()
  cmake_policy(VERSION 3.0)
  project(ypspur VERSION ${_YPSPUR_MAJOR_VERSION}.${_YPSPUR_MINOR_VERSION}.${_YPSPUR_PATCH_VERSION})
endif()

set(CVF_VERSION ${PROJECT_VERSION})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

set(YP_VENDOR_NAME "OpenSpur.org")
set(YP_PRODUCT_NAME "Yamabico Project - Spur")
set(YP_PROTOCOL_NAME "YPP:11:05")
set(YP_PARAMS_DIR "robot-params")

option(USE_SSM "Compile with SSM if available." ON)

include(GetGitRevision)
get_git_revision()
set(PROJECT_VERSION_REV "${PROJECT_VERSION} (${GIT_REVISION_SHORT})")


# Find dependencies

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

set(THREAD_LIBRARIES "")
if(THREADS_HAVE_PTHREAD_ARG)
  set(THREAD_LIBRARIES -pthread ${THREAD_LIBRARIES})
endif(THREADS_HAVE_PTHREAD_ARG)
if(CMAKE_THREAD_LIBS_INIT)
  set(THREAD_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} ${THREAD_LIBRARIES})
endif(CMAKE_THREAD_LIBS_INIT)

find_package(PkgConfig)
if(PKGCONFIG_FOUND)
  set(HAVE_PKG_CONFIG 1)
endif(PKGCONFIG_FOUND)

if(USE_SSM)
  find_package(SSM)
endif(USE_SSM)

find_package(Readline)
if(READLINE_FOUND)
  add_definitions(-DHAVE_LIBREADLINE=1)
endif(READLINE_FOUND)

include(CheckFunctionExists)
check_function_exists(longjmp HAVE_LONGJMP)
check_function_exists(siglongjmp HAVE_SIGLONGJMP)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/include/config.h
)
add_definitions(-DHAVE_CONFIG_H=1)

find_package(GTest)


# Set include dirs

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_BINARY_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/auxlib
  ${CMAKE_CURRENT_SOURCE_DIR}/auxlib/formula-calc/include
)
if(SSM_FOUND)
  include_directories(
    ${SSM_INCLUDE_DIRS}
  )
endif(SSM_FOUND)


# Static link options

option(ENABLE_ALL_STATIC "Static link libgcc and libstdc++." OFF)
set(TARGET_STATIC_POSTFIX "")
if(ENABLE_ALL_STATIC)
  set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc")
  set(CMAKE_SHARED_LINKER_FLAGS "-static-libgcc")
  set(TARGET_STATIC_POSTFIX "-static")
endif(ENABLE_ALL_STATIC)


# Add subdirectories

add_subdirectory(auxlib)
add_subdirectory(samples)


# Enable gtest

if(GTEST_FOUND)
  enable_testing()

  add_executable(param_load_test
    test/param_load.cpp
    src/adinput.c
    src/communication.c
    src/odometry.c
    src/param.c
    src/serial.c
    src/ssm_spur_handler.c
    src/utility.c
    src/yprintf.c
  )
  target_link_libraries(param_load_test
    ${GTEST_LIBRARIES}
    ${THREAD_LIBRARIES}
    carte2d${TARGET_STATIC_POSTFIX}
    formula-calc${TARGET_STATIC_POSTFIX}
  )

  add_test(YPSpurParamTest param_load_test)
endif(GTEST_FOUND)


# Build coordinator and utilities

add_executable(ypspur-coordinator
  src/adinput.c
  src/command_aux.c
  src/command.c
  src/command_get.c
  src/command_joint.c
  src/command_param.c
  src/command_run.c
  src/command_set.c
  src/communication.c
  src/control_motion.c
  src/control_vehicle.c
  src/ipcommunication.c
  src/msq.win32.c
  src/odometry.c
  src/param.c
  src/ping.c
  src/serial.c
  src/ssm_spur_handler.c
  src/utility.c
  src/ypprotocol.c
  src/yprintf.c
  src/ypspur-coordinator.c
)
target_link_libraries(ypspur-coordinator
  carte2d${TARGET_STATIC_POSTFIX} formula-calc${TARGET_STATIC_POSTFIX} m ${THREAD_LIBRARIES}
)
if(SSM_FOUND)
  target_link_libraries(ypspur-coordinator
    odomssm${TARGET_STATIC_POSTFIX}
    ${SSM_LIBRARIES}
  )
endif(SSM_FOUND)
if(WIN32)
  target_link_libraries(ypspur-coordinator wsock32 ws2_32)
endif(WIN32)

add_executable(ypspur-free
  src/ypspur-free.c
)
target_link_libraries(ypspur-free
  ypspur${TARGET_STATIC_POSTFIX}
)

add_executable(ypspur-interpreter
  src/ypspur-interpreter.c
)

target_link_libraries(ypspur-interpreter
  ypspur${TARGET_STATIC_POSTFIX}
  ${READLINE_LIBRARIES}
)


# Build libraries

set(YPSPUR_LIBRARY_VERSION 14.2.0)
set(YPSPUR_LIBRARY_SOVERSION 14)
set(YPSPUR_PUBLIC_HEADERS
  include/ypspur.h
  include/ypparam.h
)
set(YPSPUR_MD_PUBLIC_HEADERS
  include/ypspur-md.h
  include/ypparam.h
)
add_library(ypspur SHARED
  src/libypspur.c
  src/libypspur-md.c
  src/ipcommunication.c
  src/msq.win32.c
  src/yprintf.c
  src/utility.c
)

add_library(ypspur-comm SHARED
  src/communication.c
)

if(WIN32)
  target_link_libraries(ypspur wsock32 ws2_32)
endif(WIN32)
set_target_properties(ypspur PROPERTIES
  IMPORT_SUFFIX "_import.lib"
  VERSION ${YPSPUR_LIBRARY_VERSION}
  SOVERSION ${YPSPUR_LIBRARY_SOVERSION}
  PUBLIC_HEADER "${YPSPUR_PUBLIC_HEADERS}"
)

add_library(ypspur-static STATIC
  src/libypspur.c
  src/libypspur-md.c
  src/ipcommunication.c
  src/msq.win32.c
  src/yprintf.c
  src/utility.c
)
if(WIN32)
  target_link_libraries(ypspur-static wsock32 ws2_32)
endif(WIN32)
set_target_properties(ypspur-static PROPERTIES
  OUTPUT_NAME "ypspur"
  PUBLIC_HEADER "${YPSPUR_PUBLIC_HEADERS}"
)

add_library(ypspur-md SHARED
  src/libypspur-md.c
  src/ipcommunication.c
  src/msq.win32.c
  src/yprintf.c
  src/utility.c
)
if(WIN32)
  target_link_libraries(ypspur-md wsock32 ws2_32)
endif(WIN32)
set_target_properties(ypspur-md PROPERTIES
  IMPORT_SUFFIX "_import.lib"
  VERSION ${YPSPUR_LIBRARY_VERSION}
  SOVERSION ${YPSPUR_LIBRARY_SOVERSION}
  PUBLIC_HEADER "${YPSPUR_MD_PUBLIC_HEADERS}"
)

add_library(ypspur-md-static STATIC
  src/libypspur-md.c
  src/ipcommunication.c
  src/msq.win32.c
  src/yprintf.c
  src/utility.c
)
if(WIN32)
  target_link_libraries(ypspur-md-static wsock32 ws2_32)
endif(WIN32)
set_target_properties(ypspur-md-static PROPERTIES
  OUTPUT_NAME "ypspur-md"
  PUBLIC_HEADER "${YPSPUR_MD_PUBLIC_HEADERS}"
)


# Install

install(TARGETS
    ypspur-coordinator
    ypspur
    ypspur-comm
    ypspur-static
    ypspur-md
    ypspur-md-static
    ypspur-free
    ypspur-interpreter
  EXPORT YPSpurExport
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
  PUBLIC_HEADER DESTINATION include
)
install(FILES include/yp-spur.h
  DESTINATION include
)
install(FILES include/communication.h
  DESTINATION include/ypspur
)

if(SSM_FOUND)
  install(DIRECTORY
      include/ssmtype
    DESTINATION include
  )
endif(SSM_FOUND)


# Generate package config and install

install(EXPORT YPSpurExport
  DESTINATION share/ypspur/cmake/
  FILE YPSpurTargets.cmake
)

set(YPSPUR_INCLUDE_DIRS include)
set(YPSPUR_CMAKE_DIR share/ypspur/cmake)

include(CMakePackageConfigHelpers)
configure_package_config_file(cmake/ypspur-config.cmake.in
  ${PROJECT_BINARY_DIR}/cmake/ypspur/ypspur-config.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_PREFIX}/share/ypspur
  PATH_VARS YPSPUR_CMAKE_DIR YPSPUR_INCLUDE_DIRS
)
write_basic_package_version_file(
  ${PROJECT_BINARY_DIR}/cmake/ypspur/ypspur-config-version.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion
)

install(
  FILES
    ${PROJECT_BINARY_DIR}/cmake/ypspur/ypspur-config.cmake
    ${PROJECT_BINARY_DIR}/cmake/ypspur/ypspur-config-version.cmake
    package.xml
  DESTINATION share/ypspur/
)


# Generate pkgconfig file and install

configure_file(ypspur.pc.in
  ${PROJECT_BINARY_DIR}/ypspur.pc @ONLY
)

set(
  PKGCONFIG_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/pkgconfig
  CACHE PATH "Install directory of pkgconfig file"
)
install(
  FILES
    ${PROJECT_BINARY_DIR}/ypspur.pc
  DESTINATION ${PKGCONFIG_INSTALL_DIR}
)

=== samples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

# Build samples

add_executable(cartesian2d-test
	cartesian2d-test.c
)
target_link_libraries(cartesian2d-test
	carte2d${TARGET_STATIC_POSTFIX}
)

add_executable(MOI-estimate
	MOI-estimate.c
)
target_link_libraries(MOI-estimate
	ypspur${TARGET_STATIC_POSTFIX}
)

add_executable(run-test
	run-test.c
)
target_link_libraries(run-test
	ypspur${TARGET_STATIC_POSTFIX}
)

=== auxlib/formula-calc/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

set(_FORMULA_CALC_MAJOR_VERSION 0)
set(_FORMULA_CALC_MINOR_VERSION 0)
set(_FORMULA_CALC_PATCH_VERSION 1)

if(${CMAKE_MAJOR_VERSION} LESS 3)
  cmake_policy(VERSION 2.8.3)
  project(formula-calc)

  set(FORMULA_CALC_MAJOR_VERSION ${_FORMULA_CALC_MAJOR_VERSION})
  set(FORMULA_CALC_MINOR_VERSION ${_FORMULA_CALC_MINOR_VERSION})
  set(FORMULA_CALC_PATCH_VERSION ${_FORMULA_CALC_PATCH_VERSION})

  set(PROJECT_VERSION
    ${_FORMULA_CALC_MAJOR_VERSION}.${_FORMULA_CALC_MINOR_VERSION}.${_FORMULA_CALC_PATCH_VERSION})

  message(WARNING "[deprecated] CMake 2 will be obsoleted in formula-calc build at April, 2019")
else()
  cmake_policy(VERSION 3.0)
  project(formula-calc
    VERSION ${_FORMULA_CALC_MAJOR_VERSION}.${_FORMULA_CALC_MINOR_VERSION}.${_FORMULA_CALC_PATCH_VERSION})
endif()

include_directories(include)

add_library(formula-calc SHARED src/libformula-calc.c)
target_link_libraries(formula-calc m)
set_target_properties(formula-calc PROPERTIES
  IMPORT_SUFFIX "_import.lib"
  VERSION ${PROJECT_VERSION}
  SOVERSION 0
  PUBLIC_HEADER include/formula-calc.h
)

add_library(formula-calc-static STATIC src/libformula-calc.c)
target_link_libraries(formula-calc-static m)
set_target_properties(formula-calc-static PROPERTIES
  OUTPUT_NAME "formula-calc"
  PUBLIC_HEADER include/formula-calc.h
)

add_executable(formula-test src/formula-test.c)
target_link_libraries(formula-test formula-calc)
add_dependencies(formula-test formula-calc)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads)
find_package(GTest)

if(GTEST_FOUND AND THREADS_FOUND)
  enable_testing()

  set(THREAD_LIBRARIES "")
  if(THREADS_HAVE_PTHREAD_ARG)
    set(THREAD_LIBRARIES -pthread ${THREAD_LIBRARIES})
  endif(THREADS_HAVE_PTHREAD_ARG)
  if(CMAKE_THREAD_LIBS_INIT)
    set(THREAD_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} ${THREAD_LIBRARIES})
  endif(CMAKE_THREAD_LIBS_INIT)


  find_program(VALGRIND
    NAMES valgrind
  )

  include_directories(${INCLUDE_DIRECTORIES} ${GTEST_INCLUDE_DIRS})
  add_executable(libformula-calc-test test/libformula-calc-test.cpp)
  target_link_libraries(libformula-calc-test formula-calc ${GTEST_LIBRARIES} ${THREAD_LIBRARIES})

  add_test(UnitTests libformula-calc-test)

  if(VALGRIND)
    add_test(MemoryLeakTest
      ${VALGRIND} --error-exitcode=1 --leak-check=full
      ${CMAKE_CURRENT_BINARY_DIR}/libformula-calc-test
    )
  endif(VALGRIND)
endif(GTEST_FOUND AND THREADS_FOUND)


install(TARGETS
    formula-calc
    formula-calc-static
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
  PUBLIC_HEADER DESTINATION include
)

=== debian/changelog ===
ros-melodic-ypspur (1.20.0-1stretch) stretch; urgency=high

  * Add VOLT_MIN param (#151 <https://github.com/openspur/yp-spur/issues/151>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 27 Oct 2020 00:00:00 -0000

ros-melodic-ypspur (1.19.0-1stretch) stretch; urgency=high

  * Support online device dump (#147 <https://github.com/openspur/yp-spur/issues/147>)
  * Update assets to v0.0.9 (#146 <https://github.com/openspur/yp-spur/issues/146>)
  * Use snprintf instead of sprintf (#145 <https://github.com/openspur/yp-spur/issues/145>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 28 Aug 2020 00:00:00 -0000

ros-melodic-ypspur (1.18.2-1stretch) stretch; urgency=high

  * Fallback message if unable to get git revision (#142 <https://github.com/openspur/yp-spur/issues/142>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 31 Jul 2020 00:00:00 -0000

ros-melodic-ypspur (1.18.1-1stretch) stretch; urgency=high

  * Update assets to v0.0.8 (#139 <https://github.com/openspur/yp-spur/issues/139>)
  * Fix without-device mode (#136 <https://github.com/openspur/yp-spur/issues/136>)
  * Add CI job for Ubuntu Focal (#135 <https://github.com/openspur/yp-spur/issues/135>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 07 Apr 2020 00:00:00 -0000

ros-melodic-ypspur (1.18.0-1stretch) stretch; urgency=high

  * Accumulate packet lost count (#132 <https://github.com/openspur/yp-spur/issues/132>)
  * Fix torque offset gear factor (#131 <https://github.com/openspur/yp-spur/issues/131>)
  * Fix typo in error message (#130 <https://github.com/openspur/yp-spur/issues/130>)
  * Add DEVICE_TIMEOUT parameter and show packet lost error (#129 <https://github.com/openspur/yp-spur/issues/129>)
  * Fix --no-yp-protocol mode (#128 <https://github.com/openspur/yp-spur/issues/128>)
  * Add option to ping chained devices (#127 <https://github.com/openspur/yp-spur/issues/127>)
  * Update assets to v0.0.7 (#126 <https://github.com/openspur/yp-spur/issues/126>)
  * Update assets to v0.0.6 (#125 <https://github.com/openspur/yp-spur/issues/125>)
  * Migrate changelog format to rst (#124 <https://github.com/openspur/yp-spur/issues/124>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sat, 21 Mar 2020 00:00:00 -0000

ros-melodic-ypspur (1.13.2-1stretch) stretch; urgency=high

  * [AWD] Freeモードから抜ける際に加速度制限が正しく働かないバグを修正
  * [AWD] B-Loco通信無効モードのCPU使用率を低減
  * [AWD] パラメータファイルの説明を出力する起動オプションを追加(--param-help)

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 05 Apr 2012 00:00:00 -0000

ros-melodic-ypspur (1.13.1-1stretch) stretch; urgency=high

  * [AWD] sh-velのスタートアップルーチン、リンカスクリプトをオリジナルのファイルに

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 14 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.13.0-1stretch) stretch; urgency=high

  * [AWD] パラメータファイル中にロボットのサイズを記述できるように
  * [AWD] B-Locoとの通信を一切しないモードを追加(--without-device)
  * [AWD] 制御しないモードのコマンドライン引数を変更(--without-control)
  * [AWD] Windows環境で新しいgccに対応
  * [AWD] Windows環境で共有メモリとMutexの名前競合を解決
  * [AWD] Windows環境でシリアル通信のOS上のバッファをクリアできるように

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sun, 11 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.12.3-1stretch) stretch; urgency=high

  * [GND] sh-velのリセットタイマの仕様変更.YPSpur拡張コマンドの通信時はタイムアウトを長めに設定

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 06 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.12.2-1stretch) stretch; urgency=high

  * [YOK] Mac OS X環境でシリアル通信ができるようにした

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 05 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.12.1-1stretch) stretch; urgency=high

  * [GND] A/Dの値をssmに書き込む際のバッファリングのバグ修正
  * [GND] ビットレート(ボーレート)の設定のバグ修正
  * [GND] ypspur-coordinaterの初期化に失敗するとsh-velがリセットされないバグを修正(※sh-velを入れ直す必要あり)

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sun, 04 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.12.0-1stretch) stretch; urgency=high

  * [AWD] Passiveモード(押して進むモード作成)

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 14 Nov 2011 00:00:00 -0000

ros-melodic-ypspur (1.11.2-1stretch) stretch; urgency=high

  * [AWD] トルク推定の式をパラメータの単位系の修正に対応

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 03 Nov 2011 00:00:00 -0000

ros-melodic-ypspur (1.11.1-1stretch) stretch; urgency=high

  * [STK] モータ制御ゲインの計算で時間を考慮していないバグを修正
  * [STK] libodmssm.cで戻り値を使用していないバグを修正
  * [STK] パラーメータのバージョンが新しすぎても動作するバグを修正
  * [STK] MOTOR_VTCを読み込まないように修正
  * [STK] パラメータの単位系を修正（GAIN_KP, GAIN_KI, INTEGRAL_MAX, TORQUE_VISCOS）

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 31 Oct 2011 00:00:00 -0000

ros-melodic-ypspur (1.11.0-1stretch) stretch; urgency=high

  * [AWD] 並進力[N],トルク[Nm]の推定値取得コマンド追加(Spur_get_force)
  * [AWD] タイヤの出力トルク[Nm]の推定値取得コマンド追加(YP_get_wheel_torque)
  * [AWD] 出力トルクの推定値からロボットの慣性モーメントを推定するサンプル sample/MOI-estimate を追加
  * [AWD] 64bit環境用での、32bitコンパイルしたときに共有ライブラリが生成されないバグを修正
  * [AWD] 32/64bitの切り替え方法を変更、CFLAGS="-m32" ./configure のように (これまで configure --host=i686 としていたが、本来このオプションは i686-gcc というファイル名のコンパイラを使うという指定)
  * [AWD] ypspur-interpreterのコマンド解析部分のバグを修正

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sun, 30 Oct 2011 00:00:00 -0000

ros-melodic-ypspur (1.10.1-1stretch) stretch; urgency=high

  * [STK] odometry_receiveで同じデータを何度も処理するバグを修正
  * [STK] odometry_receiveで受信したデータパケット数が正しいかを確認するようにした

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 22 Sep 2011 00:00:00 -0000

ros-melodic-ypspur (1.10.0-1stretch) stretch; urgency=high

  * [STK] 一部関数の名称変更
  * [STK] msg関連の定義をypspur.hからypparam.hへ移動
  * [STK] ypspur-coordinatorの戻り値を修正
  * [STK] ssmのadjustするSNAMEをSNAME_ADJUSTに修正
  * [STK] PWS補償の項が間違っていたので修正(モータ制御PIゲインの値を変える必要があります)
  * [STK] PWS補償のゲインを質量・慣性モーメントより自動的に計算するようにした。(慣性モーメントパラメータの追加)

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 28 Jul 2011 00:00:00 -0000

ros-melodic-ypspur (1.9.0-1stretch) stretch; urgency=high

  * [GND] パラメータ取得コマンドの追加(YPSpur_parameter_get)

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 22 Jul 2011 00:00:00 -0000



=== debian/control ===
Source: ros-melodic-ypspur
Section: misc
Priority: optional
Maintainer: Atsushi Watanabe <atsushi.w@ieee.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libreadline-dev
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-ypspur
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libreadline-dev, ros-melodic-catkin
Description: YP-Spur is a mobile robot motion control software with coordinate frame based commands.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-ypspur//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-ypspur 1.20.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 2.8.3)
 
 set(_YPSPUR_MAJOR_VERSION 1)
-set(_YPSPUR_MINOR_VERSION 17)
-set(_YPSPUR_PATCH_VERSION 1)
+set(_YPSPUR_MINOR_VERSION 20)
+set(_YPSPUR_PATCH_VERSION 2)
 
 if(${CMAKE_MAJOR_VERSION} LESS 3)
 # DARN_IT: CMake 2 should be supported until April, 2019 (Ubuntu Trusty EOL)

=== auxlib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

set(CARTE2D_LIBRARY_VERSION 0.0.0)
set(CARTE2D_LIBRARY_SOVERSION 0)
add_library(carte2d SHARED libcarte2d.c)
target_link_libraries(carte2d m)
set_target_properties(carte2d PROPERTIES
  IMPORT_SUFFIX "_import.lib"
  VERSION ${CARTE2D_LIBRARY_VERSION}
  SOVERSION ${CARTE2D_LIBRARY_SOVERSION}
  PUBLIC_HEADER cartesian2d.h
)

add_library(carte2d-static STATIC libcarte2d.c)
target_link_libraries(carte2d-static m)
set_target_properties(carte2d-static PROPERTIES
  OUTPUT_NAME "carte2d"
  PUBLIC_HEADER cartesian2d.h
)

install(TARGETS
    carte2d
    carte2d-static
  EXPORT YPSpurExport
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
  PUBLIC_HEADER DESTINATION include
)

if(SSM_FOUND)
  set(ODOMSSM_LIBRARY_VERSION 0.0.1)
  set(ODOMSSM_LIBRARY_SOVERSION 0)
  add_library(odomssm SHARED libodomssm.c)
  target_link_libraries(odomssm ${SSM_LIBRARIES})
  set_target_properties(odomssm PROPERTIES 
    VERSION ${ODOMSSM_LIBRARY_VERSION}
    SOVERSION ${ODOMSSM_LIBRARY_SOVERSION}
    PUBLIC_HEADER odometry-ssm.h
  )
  set_target_properties(odomssm PROPERTIES IMPORT_SUFFIX "_import.lib")

  add_library(odomssm-static STATIC libodomssm.c)
  target_link_libraries(odomssm-static ${SSM_LIBRARIES})
  set_target_properties(odomssm-static PROPERTIES
    OUTPUT_NAME "odomssm"
    PUBLIC_HEADER odometry-ssm.h
  )

  install(TARGETS
      odomssm
      odomssm-static
    EXPORT YPSpurExport
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin
    PUBLIC_HEADER DESTINATION include
  )
endif(SSM_FOUND)

add_subdirectory(formula-calc)

=== debian/changelog ===
ros-melodic-ypspur (1.20.2-1bionic) bionic; urgency=high

  * Revert "Fix timestamp estimation (#169 <https://github.com/openspur/yp-spur/issues/169>)" (#172 <https://github.com/openspur/yp-spur/issues/172>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 17 Mar 2021 00:00:00 -0000

ros-melodic-ypspur (1.20.1-1bionic) bionic; urgency=high

  * Fix timestamp estimation (#169 <https://github.com/openspur/yp-spur/issues/169>)
  * Update assets to v0.1.4 (#164 <https://github.com/openspur/yp-spur/issues/164>)
  * Migrate to GitHub Actions (#166 <https://github.com/openspur/yp-spur/issues/166>)
  * Update static_assert availability check (#163 <https://github.com/openspur/yp-spur/issues/163>)
  * Add static_assert to enum value overlap (#162 <https://github.com/openspur/yp-spur/issues/162>)
  * Fix version in CMakeLists (#161 <https://github.com/openspur/yp-spur/issues/161>)
  * Fix git directory on release-candidate (#159 <https://github.com/openspur/yp-spur/issues/159>)
  * Automatically update version in CMakeLists (#157 <https://github.com/openspur/yp-spur/issues/157>)
  * Update assets to v0.1.2 (#156 <https://github.com/openspur/yp-spur/issues/156>)
  * Update assets to v0.0.10 (#154 <https://github.com/openspur/yp-spur/issues/154>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 10 Mar 2021 00:00:00 -0000

ros-melodic-ypspur (1.20.0-1bionic) bionic; urgency=high

  * Add VOLT_MIN param (#151 <https://github.com/openspur/yp-spur/issues/151>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 27 Oct 2020 00:00:00 -0000

ros-melodic-ypspur (1.19.0-1bionic) bionic; urgency=high

  * Support online device dump (#147 <https://github.com/openspur/yp-spur/issues/147>)
  * Update assets to v0.0.9 (#146 <https://github.com/openspur/yp-spur/issues/146>)
  * Use snprintf instead of sprintf (#145 <https://github.com/openspur/yp-spur/issues/145>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 28 Aug 2020 00:00:00 -0000

ros-melodic-ypspur (1.18.2-1bionic) bionic; urgency=high

  * Fallback message if unable to get git revision (#142 <https://github.com/openspur/yp-spur/issues/142>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 31 Jul 2020 00:00:00 -0000

ros-melodic-ypspur (1.18.1-1bionic) bionic; urgency=high

  * Update assets to v0.0.8 (#139 <https://github.com/openspur/yp-spur/issues/139>)
  * Fix without-device mode (#136 <https://github.com/openspur/yp-spur/issues/136>)
  * Add CI job for Ubuntu Focal (#135 <https://github.com/openspur/yp-spur/issues/135>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 07 Apr 2020 00:00:00 -0000

ros-melodic-ypspur (1.18.0-1bionic) bionic; urgency=high

  * Accumulate packet lost count (#132 <https://github.com/openspur/yp-spur/issues/132>)
  * Fix torque offset gear factor (#131 <https://github.com/openspur/yp-spur/issues/131>)
  * Fix typo in error message (#130 <https://github.com/openspur/yp-spur/issues/130>)
  * Add DEVICE_TIMEOUT parameter and show packet lost error (#129 <https://github.com/openspur/yp-spur/issues/129>)
  * Fix --no-yp-protocol mode (#128 <https://github.com/openspur/yp-spur/issues/128>)
  * Add option to ping chained devices (#127 <https://github.com/openspur/yp-spur/issues/127>)
  * Update assets to v0.0.7 (#126 <https://github.com/openspur/yp-spur/issues/126>)
  * Update assets to v0.0.6 (#125 <https://github.com/openspur/yp-spur/issues/125>)
  * Migrate changelog format to rst (#124 <https://github.com/openspur/yp-spur/issues/124>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sat, 21 Mar 2020 00:00:00 -0000

ros-melodic-ypspur (1.13.2-1bionic) bionic; urgency=high

  * [AWD] Freeモードから抜ける際に加速度制限が正しく働かないバグを修正
  * [AWD] B-Loco通信無効モードのCPU使用率を低減
  * [AWD] パラメータファイルの説明を出力する起動オプションを追加(--param-help)

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 05 Apr 2012 00:00:00 -0000

ros-melodic-ypspur (1.13.1-1bionic) bionic; urgency=high

  * [AWD] sh-velのスタートアップルーチン、リンカスクリプトをオリジナルのファイルに

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 14 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.13.0-1bionic) bionic; urgency=high

  * [AWD] パラメータファイル中にロボットのサイズを記述できるように
  * [AWD] B-Locoとの通信を一切しないモードを追加(--without-device)
  * [AWD] 制御しないモードのコマンドライン引数を変更(--without-control)
  * [AWD] Windows環境で新しいgccに対応
  * [AWD] Windows環境で共有メモリとMutexの名前競合を解決
  * [AWD] Windows環境でシリアル通信のOS上のバッファをクリアできるように

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sun, 11 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.12.3-1bionic) bionic; urgency=high

  * [GND] sh-velのリセットタイマの仕様変更.YPSpur拡張コマンドの通信時はタイムアウトを長めに設定

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 06 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.12.2-1bionic) bionic; urgency=high

  * [YOK] Mac OS X環境でシリアル通信ができるようにした

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 05 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.12.1-1bionic) bionic; urgency=high

  * [GND] A/Dの値をssmに書き込む際のバッファリングのバグ修正
  * [GND] ビットレート(ボーレート)の設定のバグ修正
  * [GND] ypspur-coordinaterの初期化に失敗するとsh-velがリセットされないバグを修正(※sh-velを入れ直す必要あり)

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sun, 04 Dec 2011 00:00:00 -0000

ros-melodic-ypspur (1.12.0-1bionic) bionic; urgency=high

  * [AWD] Passiveモード(押して進むモード作成)

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 14 Nov 2011 00:00:00 -0000

ros-melodic-ypspur (1.11.2-1bionic) bionic; urgency=high

  * [AWD] トルク推定の式をパラメータの単位系の修正に対応

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 03 Nov 2011 00:00:00 -0000

ros-melodic-ypspur (1.11.1-1bionic) bionic; urgency=high

  * [STK] モータ制御ゲインの計算で時間を考慮していないバグを修正
  * [STK] libodmssm.cで戻り値を使用していないバグを修正
  * [STK] パラーメータのバージョンが新しすぎても動作するバグを修正
  * [STK] MOTOR_VTCを読み込まないように修正
  * [STK] パラメータの単位系を修正（GAIN_KP, GAIN_KI, INTEGRAL_MAX, TORQUE_VISCOS）

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 31 Oct 2011 00:00:00 -0000



=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,9 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+
+# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
+export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 %:
 	dh $@ -v --buildsystem=cmake
@@ -50,7 +53,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-ypspur//opt/ros/melodic/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-ypspur//opt/ros/melodic/lib/:$(CURDIR)/debian/ros-melodic-ypspur//opt/ros/melodic/lib/${DEB_HOST_MULTIARCH}
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
